###############################################################################
# Display.pl                                                                  #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.1                                        #
# Released:       December 2001; Updated March 22, 2002                       #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2002 Xnull (www.xnull.com) - All Rights Reserved.        #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
###############################################################################

$displayplver = "1 Gold - SP 1.1";

sub Display {
        require "$sourcedir/Karma.pl";
	my $viewnum = $INFO{'num'};
	if( $viewnum =~ /\D/ ) { &fatal_error($txt{'337'}); }
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
	$maxmessagedisplay ||= 10;
	## hide mod
	my ($showhide,$tempdef);
	## hide mod
	my($buffer,$views,$lastposter,$moderators,$counter,$counterwords,$pageindex,$msubthread,$mnum,$mstate,$mdate,$msub,$mname,$memail,$mreplies,$musername,$micon,$noposting,$threadclass,$notify,$max,$start,$bgcolornum,$windowbg,$mattach,$mip,$mlm,$mlmb,$lastmodified,$postinfo,$star,$sendm,$topicdate);
	my(@userprofile,@messages,@bgcolors);

	# Determine what category we are in.
	fopen(FILE, "$boardsdir/$currentboard.ctb") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.ctb");
	$curcat = <FILE>;
	fclose(FILE);
	#$curcat = $cat;
	fopen(FILE, "$boardsdir/$curcat.cat") || &fatal_error("300 $txt{'106'}: $txt{'23'} $cat.cat");
	$cat = <FILE>;
	fclose(FILE);

	# Load the membergroups list.
	fopen(FILE, "$vardir/membergroups.txt") || &fatal_error("100 $txt{'106'}: $txt{'23'} membergroups.txt");
	@membergroups = <FILE>;
	fclose(FILE);

	# Mark current thread as read.
	($mnum,$tmpa,$tmpa,$tmpa,$mdate) = split(/\|/,$yyThreadLine);
	&dumplog($mnum,$date);

	# Add 1 to the number of views of this thread.
	if(fopen(FILE, "$datadir/$viewnum.data")) {
		$tmpa = <FILE>;
		fclose(FILE);
	}
	elsif( -e "$datadir/$viewnum.data" ) { &fatal_error("102 $txt{'106'}: $txt{'23'} $viewnum.data"); }
	else { $tmpa = '0'; }
	($tmpa, $tmpb) = split( /\|/, $tmpa );
	$tmpa++;
	fopen(FILE, "+>$datadir/$viewnum.data") || &fatal_error("103 $txt{'106'}: $txt{'23'} $viewnum.data");
	print FILE qq~$tmpa|$tmpb~;
	fclose(FILE);
	$views = $tmpa - 1;

	# Check to make sure this thread isn't locked.
	($mnum,$msubthread,$mname,$memail,$mdate,$mreplies,$musername,$micon,$mstate) = split( /\|/, $yyThreadLine );
	$noposting = $viewnum eq $mnum && $mstate == 1 ? 1 : 0;

	# Look for a poll file for this thread.
	if (-e "$datadir/$viewnum.poll") { $has_poll = 1; } else { $has_poll = 0; }

	# Get the class of this thread, based on lock status and number of replies.
	$replybutton = qq~<a href="$cgi;action=post;num=$viewnum;title=$txt{'116'}">$img{'reply'}</a>~;
	$pollbutton = qq~$menusep<a href="$cgi;action=post;num=$viewnum;title=$polltxt{'2a'}">$img{'addpoll'}</a>~;
	$threadclass = 'thread';
	if( $mstate == 1 ) {
		$threadclass = 'locked';
		$replybutton = "";
		$pollbutton = "";
	}
	if ($has_poll || $useraddpoll == 0) { $pollbutton = ""; }
	elsif( $mreplies > 24 ) { $threadclass = 'veryhotthread'; }
	elsif( $mreplies > 14 ) { $threadclass = 'hotthread'; }
	elsif( $mstate == 0 ) { $threadclass = 'thread'; }
	fopen(FILE, "$boardsdir/sticky.stk") || &fatal_error("300 $txt{'106'}: $txt{'23'} sticky.stk");
	@stickys = <FILE>;
	fclose(FILE);
	foreach $curnum (@stickys) {
		if ($mnum == $curnum) {
			if($threadclass eq 'locked') { $threadclass = 'stickylock'; }
			else { $threadclass = 'sticky'; }
		}
	}

	&LoadCensorList;	# Load Censor List

	# Build a list of this board's moderators.
	if( scalar keys %moderators > 0 ) {
		if( scalar keys %moderators == 1 ) { $showmods = qq~($txt{'298'}: ~; }
		else { $showmods = qq~($txt{'299'}: ~; }
		while( $_ = each(%moderators) ) {
			&FormatUserName($_);
			$showmods .= qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$_}" class="nav">$moderators{$_}</a>, ~;
		}
		$showmods =~ s/, \Z/)/;
	}

	if($enable_notification) {
		my $startnum = $start || '0';
		$notify = qq~$menusep<a href="$cgi;action=notify;thread=$viewnum;start=$startnum">$img{'notify'}</a>~;
	}
	&jumpto;	# create the jumpto list

	# look for thread header for this topic
	if (-e "$datadir/$viewnum.head") { require "$sourcedir/ThreadHeader.pl"; &ShowHeader($viewnum);}

	# Build the page links list.
if ($INFO{'showall'} eq "true") { $maxmessagedisplay = $mreplies + 1; }
	$postdisplaynum = 3;	# max number of pages to display
	$max = $mreplies + 1;
	$start = $INFO{'start'} || 0;
	$start = $start > $mreplies ? $mreplies : $start;
	$start = ( int( $start / $maxmessagedisplay ) ) * $maxmessagedisplay;
	$tmpa = 1;
	$tmpx = int( $max / $maxmessagedisplay );
	if ($start >= (($postdisplaynum-1) * $maxmessagedisplay)) { $startpage = $start - (($postdisplaynum-1) * $maxmessagedisplay); $tmpa = int( $startpage / $maxmessagedisplay ) + 1; }
	if ($max >= $start + ($postdisplaynum * $maxmessagedisplay)) { $endpage = $start + ($postdisplaynum * $maxmessagedisplay); } else { $endpage = $max }
	if ($mreplies > $maxmessagedisplay) { $pageindex = qq~<A href="$cgi;action=display;num=$mnum;start=0;showall=true">$txt_sb{'1001'}</a>&nbsp;~; }	else{ $pageindex = ""; }	if ($startpage > 0) { $pageindex .= qq~<a href="$cgi;action=display;num=$viewnum;start=0">1</a>&nbsp;...&nbsp;~; }	if ($startpage == $maxmessagedisplay) { $pageindex .= qq~<a href="$cgi;action=display;num=$viewnum;start=0">1</a>&nbsp;~;}
	for( $counter = $startpage; $counter < $endpage; $counter += $maxmessagedisplay ) {
		$pageindex .= $start == $counter ? qq~<b>$tmpa</b>&nbsp;~ : qq~<a href="$cgi;action=display;num=$viewnum;start=$counter">$tmpa</a>&nbsp;~;
		$tmpa++;
	}
	$tmpx = $max - $maxmessagedisplay;
	$outerpn = int($tmpx / $maxmessagedisplay) + 0;
	$lastpn = int($mreplies / $maxmessagedisplay) + 1;
	$lastptn = ($lastpn - 1) * $maxmessagedisplay;
	if ($endpage < $max - ($maxmessagedisplay) ) {$pageindexadd = qq~&nbsp;...&nbsp;~;}
	if ($endpage != $max) {$pageindexadd .= qq~&nbsp;<a href="$cgi;action=display;num=$viewnum;start=$lastptn">$lastpn</a>~;}
	$pageindex .= $pageindexadd;

	foreach (@censored) {
		($tmpa,$tmpb) = @{$_};
		$msubthread =~ s~\Q$tmpa\E~$tmpb~gi;
	}
	$curthreadurl = $curposlinks ? qq~<a href="$cgi;action=display;num=$viewnum" class="nav">$msubthread</a>~ : $msubthread;

	# Create next/prev links
	fopen(LISTS, "$boardsdir/$INFO{'board'}.txt");
	@boardtopics = <LISTS>;
	seek LISTS, 0, 0;
	my $found;
	my $name = $INFO{'num'};
	my $bcount = 0;
	$CurrentPosition = -1;
	while($ThreadNum = <LISTS>) {
		++$CurrentPosition;
		$boardtopics[$bcount] = $ThreadNum;
		$bcount++;
		if ($ThreadNum =~ m/\A$name/o) { $found = 1; last; }
	}
	fclose(LISTS);
	$previous = $boardtopics[$CurrentPosition-1];
	$next = $boardtopics[$CurrentPosition+1];
	@prevthread = split(/\|/, $previous);
	$goprevious = $prevthread[0];
	@nextthread = split(/\|/, $next);
	$gonext = $nextthread[0];
	@getlastthread = @boardtopics;
	$lastthread = pop(@getlastthread);
	@lasttopic = split(/\|/, $lastthread);
	$endthread2 = $lasttopic[0];
	if($found) {
		$prevtopic = "$cgi;action=display;num=$goprevious";
		$nexttopic = "$cgi;action=display;num=$gonext";
		$endthread = "$cgi;action=display;num=$endthread2";
	}
	if( $endthread eq $prevtopic && $gonext eq "") { $nav = qq~ $txt{'766'} | $txt{'766'} &#187;~; }
	if($endthread eq $prevtopic && $gonext ne "") { $nav = qq~ $txt{'766'} | <a href="$nexttopic">$txt{'767'}</a> &#187;~; }
	if ( $endthread ne $prevtopic && $gonext eq "") { $nav = qq~ <a href="$prevtopic">$txt{'768'}</a> | $txt{'766'} &#187;~; }
	if ($endthread ne $prevtopic && $gonext ne "") { $nav = qq~ <a href="$prevtopic">$txt{'768'}</a> | <a href="$nexttopic">$txt{'767'}</a> &#187;~; 	}
	$yymain .= qq~
<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
<object classid="clsid:F3A614DC-ABE0-11d2-A441-00C04F795683" codebase="#Version=2,0,0,83" codetype=application/x-oleobject id=MsgrObj width=0 height=0>
</object>
<OBJECT classid="clsid:FB7199AB-79BF-11d2-8D94-0000F875C541" codeType=application/x-oleobject id=MsgrApp width=0 height=0></OBJECT>
<SCRIPT LANGUAGE="JavaScript">           
<!--            
function stopError() {             return true;           }            
window.onerror = stopError;            
// -->
</script>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr>
    <td valign=bottom colspan="2"><a name="top"><font size="2" class="nav"><B>
    <img src="$imagesdir/open.gif" border="0" alt="">&nbsp;&nbsp;
    <a href="$scripturl" class="nav">$mbname</a><br>
    <img src="$imagesdir/tline.gif" border="0" alt=""><IMG SRC="$imagesdir/open.gif" border="0" alt="">&nbsp;&nbsp;
    <a href="$scripturl#$curcat" class="nav">$cat</a><br>
    <img src="$imagesdir/tline2.gif" border="0" alt=""><IMG SRC="$imagesdir/open.gif" border="0" alt="">&nbsp;&nbsp;
    <a href="$cgi" class="nav">$boardname</a> </b><font size="1">$showmods</font><b><br>
    <img SRC="$imagesdir/tline3.gif" border="0" alt=""><IMG SRC="$imagesdir/open.gif" border="0" alt="">&nbsp;&nbsp;
    $curthreadurl</b></font></td>
    <td valign="bottom" align="right"><font size="1">&#171; <a href="$cgi;action=post;title=$txt{'464'}">$txt{'767a'}</a> | $nav</font></td>
  </tr>
</table>
<table border="0" width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">
        <table cellpadding="3" cellspacing="0" width="100%">
          <tr>
            <td><font size="2"><b>$txt{'139'}:</b> $pageindex</font></td>
            <td class="catbg" bgcolor="$color{'catbg'}" align="right"><font size="2">
            $replybutton$pollbutton$notify$menusep
            <a href="$cgi;action=sendtopic;topic=$viewnum">$img{'sendtopic'}</a>$menusep
            <a href="$cgi;action=print;board=$currentboard;num=$viewnum" target="_blank">$img{'print'}</a>
            </font></td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>



~;
	if ($has_poll) { require "$sourcedir/Poll.pl"; &display_poll($viewnum); }
	$yymain .= qq~

<form name="multidel" action="$scripturl?board=$currentboard;thread=$viewnum;action=multidel;s tart=$start" method="POST" style="display: inline">  
<input type="hidden" name="maxmessage" value="$maxmessagedisplay">

<table cellpadding="0" cellspacing="0" border="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td>
    <table cellpadding="3" cellspacing="1" border="0" width="100%">
      <tr>
        <td valign="middle" align="left" width="20%" bgcolor="$color{'titlebg'}" class="titlebg">
        <font size=2 class="text1" color="$color{'titletext'}">&nbsp;<img src="$imagesdir/$threadclass.gif" alt="">
        &nbsp;<b>$txt{'29'}</b></font></td>
        <td valign="middle" align="left" bgcolor="$color{'titlebg'}" class="titlebg" width="80%">
        <font size=2 class="text1" color="$color{'titletext'}"><b>&nbsp;$txt{'118'}: $msubthread</b> &nbsp;($txt{'641'} $views $txt{'642'})</font></td>
      </tr>
    </table>
    </td>
  </tr>
</table>
~;

	# Load background color list.
	@bgcolors = ( $color{windowbg}, $color{windowbg2} );
	$bgcolornum = scalar @bgcolors;
	@cssvalues = ( "windowbg","windowbg2" );
	$cssnum = scalar @bgcolors;

	if(!$MenuType) { $sm = 1; }
	$counter = 0;

	fopen(FILE,"$datadir/$viewnum.txt") || &fatal_error("104 $txt{'106'}: $txt{'23'} $viewnum.txt");

	# Skip past the posts in this thread until we reach $start.
	while($counter < $start && ($buffer = <FILE>)) { $counter++; }

	$#messages = $maxmessagedisplay - 1;
	for($counter = 0; $counter < $maxmessagedisplay && ($buffer = <FILE>); $counter++) {
		$messages[$counter] = $buffer;
	}
	fclose(FILE);
	### hide mod
	$showhide='';
	fopen(FILE,"$datadir/$viewnum.txt") || &fatal_error("104 $txt{'106'}: $txt{'23'} $viewnum.txt");
	@messages2 = <FILE>;
	fclose(FILE);
	foreach $tempdef (@messages2)
	{
		chomp($tempdef);
		($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $postmessage, $ns, $mlm, $mlmb) = split(/[\|]/, $tempdef);
		if( $musername eq $username && $username ne 'Guest')
		{ $showhide ='doit';}
	}
	### hide mod
	$#messages = $counter - 1;
	$counter = $start;


	fopen(FILE,"$vardir/hotlink.txt") || &fatal_error("205 $txt{'106'}: $txt{'23'} hotlink.txt");
	@hotlinks = <FILE>;
	fclose(FILE);

	# For each post in this thread:
	foreach (@messages) {
		$windowbg = $bgcolors[($counter % $bgcolornum)];
		$css = $cssvalues[($counter % $cssnum)];
		chomp;
		($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $postmessage, $ns, $mlm, $mlmb) = split(/[\|]/, $_);
$lastmoduser = $mlmb;
		# Should we show "last modified by?"
		if( $mlm && $showmodify && $mlm ne "" && $mlmb ne "") {
			$mlm = &timeformat($mlm);
			&LoadUser($mlmb);
			$mlmb = $userprofile{$mlmb}->[1] || $mlmb || $txt{'470'};
			$lastmodified = qq~&#171; <i>$txt{'211'}: $mlm $txt{'525'} $mlmb</i> &#187;~;
		}
		else {
			$mlm = '-';
			$lastmodified = '';
		}
		$msub ||= $txt{'24'};
		$messdate = &timeformat($mdate);
		$mip = $settings[7] eq 'Administrator' ? $mip : "$txt{'511'}";
		$sendm = '';

		# If the user isn't a guest, load his/her info.
		  $online = "";
  if($musername ne 'Guest' && ! $yyUDLoaded{$musername} && -e("$memberdir/$musername.dat") ) {
			&LoadUserDisplay($musername);	# If user is not in memory, s/he must be loaded.
			my($loccode, $displocal, $dispcountry, $dispcontin, $dispx, $dispy, $dispstate, $dispflag, $disptext);
		}
		if($yyUDLoaded{$musername}) {
			@userprofile = @{$userprofile{$musername}};
	($loccode, $displocal, $dispcountry, $dispcontin, $dispx, $dispy, $dispstate) = split(/\|/, $userprofile[15]);
	if($dispcountry ne "") {
		if($view_flag) {
			if($loccode eq "x1") { $dispflag = qq~<a href="$scripturl?board=$currentboard;action=viewprofile;username=$useraccount{$musername}#mmap"><img src="$imagesdir/flag/$dispcountry.gif" vspace=3 border=0 align="absmiddle" alt="$dispcountry"></a>&nbsp;~; }
			elsif($loccode eq "x0") { $dispflag = qq~<img src="$imagesdir/flag/$dispcountry.gif" vspace=3 border=0 align="absmiddle" alt="$dispcountry">&nbsp;~; }
			else { $dispflag = ""; }
		}
		if($view_text) {
			my($initstat, $namestat, $disploc);
			if($dispstate ne "") { ($initstat, $namestat) = split(/\,/, $dispstate); }
			if($displocal ne "") { $disploc = qq~$displocal $initstat~; }
			if($loccode eq "x1") { $disptext = qq~<nobr><font size="1"><a href="$scripturl?board=$currentboard;action=viewprofile;username=$useraccount{$musername}#mmap">$disploc</a></font></nobr>~; }
			elsif($loccode eq "x0") { $disptext = qq~<nobr><font size="1">$disploc</font></nobr>~; }
			else { $disptext = ""; }
		}
	}
			$displayname = $userprofile[1];
			$star = $memberstar{$musername};
			$memberinfo = $memberinfo{$musername};
			$memberinfo =~ s~\n~~g;
			$icqad = $icqad{$musername};
			$yimon = $yimon{$musername};
			if($username ne 'Guest') {
				# Allow instant message sending if current user is a member.
				$sendm = qq~$menusep<a href="$cgi;action=imsend;to=$useraccount{$musername}">$img{'message_sm'}</a>~;
			}
			$usernamelink = qq~<a href="$scripturl?board=$currentboard;action=viewprofile;username=$useraccount{$musername}"><font size="2"><b>$userprofile[1]</b></font></a>~;
			$postinfo = qq~$txt{'26'}: $userprofile[6]<br>~;
			$memail = $userprofile[2];
   $online = "";
   fopen(FILE, "$vardir/log.txt");
   @entries = <FILE>;
   fclose(FILE);
   # $online = qq~<font size="1">(<i>Offline</i>)</font>~;
   $online = qq~<img src="$imagesdir/redoff.gif" border="0"><font face="impact" color="red" size="3">  .::   OFFLINE</font>~;
   foreach $curentry (@entries) {
   chomp $curentry;
   ($name, $value) = split(/\|/, $curentry);
   if( $name eq $musername)  
     {
     $online = qq~<img src="$imagesdir/greenon.gif" border="0"><font face="impact" color="white" size="3">  .::   LOGGED IN</font>~;  
     }
   }
        	        $karmainfo = "<br>$karmaLabel " . &getKarma($musername);
                        my($inMemberGroup) = &isInMemberGroup;
                	if (($username ne "Guest") && ($inMemberGroup == 1)){
	                  $karmainfo .= "<br><a href=\"$cgi\&action=modifyKarma\&username=$musername\&karmaAction=smite\">$karmaSmiteLabel</a> <a href=\"$cgi\&action=modifyKarma\&username=$musername\&karmaAction=applaud\">$karmaApplaudLabel</a>";
        	        }
			### Begin HTML MOD
			if ($postmessage =~ /\#enable_html/isg) {
				$html_username = $musername;
				if ($lastmoduser ne $html_username && $lastmoduser ne '') {
					$html_username = $lastmoduser;
				}
				$message_backup = $postmessage; # since $message is no local variable, it often gets overwritten accidently somehwere (couldn't find out where)
				$enable_html = HTML_allow($html_username);
				$postmessage = $message_backup;
				if ($enable_html == 1) { $postmessage =~ s/\#enable_html//isg; }
			} else { $enable_html = 0; }
			### End HTML MOD
		}
		else {
			$musername = "Guest";
			$star = '';
			$memberinfo = "$txt{'28'}";
			$icqad = '';
			$yimon = '';
			$usernamelink = qq~<font size="2"><b>$mname</b></font>~;
			$postinfo = '';
			@userprofile = ();
			$displayname = $mname;
		}
		# Censor the subject and message.
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$postmessage =~ s~\Q$tmpa\E~$tmpb~gi;
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}

		foreach $line (@hotlinks) {
			$htmpa = ""; $htmpb = ""; $htmpc = ""; $htmpc2 = ""; $tmptarget = "";
			($htmp,$htmpb) = split(/=/,$line,2);
			($htmpa,$tmptarget) = split(/\,/,$htmp,2);

			if($htmpb !~ m~\Ahttp://~) {
				if($tmptarget) { $htmpc = qq(\[url=http://$htmpb\]); $htmpc2 = qq(\[/url\]); }
				else { $htmpc = qq(\[link=http://$htmpb\]); $htmpc2 = qq(\[/link\]); }
			}
			else {
				if($tmptarget) { $htmpc = qq(\[url=$htmpb\]); $htmpc2 = qq(\[/url\]); }
				else { $htmpc = qq(\[link=$htmpb\]); $htmpc2 = qq(\[/link\]); }
			}

			$postmessage =~ s~(^|\s)\u$htmpa(?=$|\s|\.|\,|\;|\:)~ $htmpc\u$htmpa$htmpc2~g;
			$postmessage =~ s~\<br\>\u$htmpa\s~\<br\>$htmpc\u$htmpa$htmpc2 ~g;
			$postmessage =~ s~\s\u$htmpa\<br\>~ $htmpc\u$htmpa$htmpc2\<br\>~g;
			$postmessage =~ s~\<br\>\u$htmpa\<br\>~\<br\>$htmpc\u$htmpa$htmpc2 \<br\>~g;
			$postmessage =~ s~\[b\]\u$htmpa\[\/b\]~$htmpc\[b\]\u$htmpa\[\/b\]$htmpc2~g;
			$postmessage =~ s~\[i\]\u$htmpa\[\/i\]~$htmpc\[i\]\u$htmpa\[\/i\]$htmpc2~g;
			$postmessage =~ s~\[u\]\u$htmpa\[\/u\]~$htmpc\[u\]\u$htmpa\[\/u\]$htmpc2~g;
			$postmessage =~ s~\[s\]\u$htmpa\[\/s\]~$htmpc\[s\]\u$htmpa\[\/s\]$htmpc2~g;
			$postmessage =~ s~(^|\s)\l$htmpa(?=$|\s|\.|\,|\;|\:)~ $htmpc\l$htmpa$htmpc2~g;
			$postmessage =~ s~\<br\>\l$htmpa\s~\<br\>$htmpc\l$htmpa$htmpc2 ~g;
			$postmessage =~ s~\s\l$htmpa\<br\>~ $htmpc\l$htmpa$htmpc2\<br\>~g;
			$postmessage =~ s~\<br\>\l$htmpa\<br\>~\<br\>$htmpc\l$htmpa$htmpc2 \<br\>~g;
			$postmessage =~ s~\[b\]\l$htmpa\[\/b\]~$htmpc\[b\]\l$htmpa\[\/b\]$htmpc2~g;
			$postmessage =~ s~\[i\]\l$htmpa\[\/i\]~$htmpc\[i\]\l$htmpa\[\/i\]$htmpc2~g;
			$postmessage =~ s~\[u\]\l$htmpa\[\/u\]~$htmpc\[u\]\l$htmpa\[\/u\]$htmpc2~g;
			$postmessage =~ s~\[s\]\l$htmpa\[\/s\]~$htmpc\[s\]\l$htmpa\[\/s\]$htmpc2~g;
		}

		# Run UBBC interpreter on the message.
		$message = $postmessage; # put the message back into the proper variable to do ubbc on it
		### hide mod
		if( $message =~ /\[hide\]/ && $showhide ne 'doit')
		{
		
		$message =~ s/\[hide\](.+?)\[\/hide\]/\[HIDDEN\]/g;

		}
		### hide mod
		&wrap;
		if($enable_ubbc && $enable_html != 1) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
		&wrap2;
		$profbutton = $profilebutton && $musername ne 'Guest' ? qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}">$img{'viewprofile_sm'}</a>$menusep~ : '';
		if($counter != 0) { $counterwords = "$txt{'146'} #$counter"; }
		else { $counterwords = ""; }
if($enable_html == 1) { &FromHTML($message); }
		# Print the post and user info for the poster.
		$yymain .= qq~
<a name="$counter"></a>
<table cellpadding="0" cellspacing="0" border="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td>
    <table cellpadding="3" cellspacing="1" border="0" width="100%">
      <tr>
        <td bgcolor="$windowbg" class="$css">
        <table width='100%' cellpadding='4' cellspacing='0' class="$css" bgcolor="$windowbg">
          <tr>
            <td class="$css" bgcolor="$windowbg" valign="top" width="20%" rowspan="2"><font size="1">
            $usernamelink<BR>
            $memberinfo<BR>~;
	if($musername ne "Guest") {
  
  if($view_flag) { $yymain .= qq~$dispflag ~; }
  if($view_text) { $yymain .= qq~$disptext~; }
  if($view_flag || $view_text) { $yymain .= qq~<br>~; }

  $yymain .= qq~
  $star<BR>
 $online<BR>
	    $karmainfo
            $userprofile[13]$userprofile[12]

                      ~; }

if($columnpostshowbottom == '0' && ( $musername ne 'Guest' ))  {  $yymain .= qq~

  $userprofile[8] $icqad &nbsp;~;

	fopen(FILE, "$memberdir/$useraccount{$musername}.om", 1); 
        @msnsettings = <FILE>;
        fclose <FILE>;
        chomp @msnsettings;   
            if ($msnsettings[0] ne '')
            {
$yymain .= qq~
           <a id="lll" href=javascript:MsgrApp.LaunchIMUI("$msnsettings[0]")><img src="$imagesdir/msntalk.gif" alt="Chat to $msnsettings[0]" border=0></a> &nbsp; 
           <a href=javascript:MsgrApp.LaunchAddContactUI("$msnsettings[0]")><img src="$imagesdir/msnadd.gif" alt="Add $msnsettings[0] to your Buddy List" border=0></a> &nbsp;~;
        }



 $yymain .= qq~

            <BR>$userprofile[10] $yimon &nbsp; $userprofile[9]<BR>
~;


	if ($userprofile[19] ne "checked" || $settings[7] eq "Administrator" || $allow_hide_email ne 1) {
		$yymain .= qq~
            $profbutton$userprofile[4] <a href="mailto:$memail">$img{'email_sm'}</a>$sendm<BR><BR>
~;
	} else {
		$yymain .= qq~
    $profbutton$userprofile[4]$sendm<BR><BR>
~;
	}

}


if($musername eq "Guest") {
		$yymain .= qq~
            <BR><a href="mailto:$memail">$img{'email_sm'}</a><BR><BR>
~;
	}

	$yymain .= qq~
<br>        $userprofile[11]
            $postinfo
~;
require "$sourcedir/ExtendedProfiles.pl";
$yymain .= ext_viewinposts($musername) . qq~
            <br><br>$avgpost{$musername}
	<p><a href="#top">Back to top</a></p>
            </font><br>
	<font size="1"><img src="$imagesdir/ip.gif" alt="" border="0"> $mip</font></td>
	<td class="$css" bgcolor="$windowbg" valign="top" width="80%" height="100%">
            <table width='100%' border='0'>
              <tr>
                <td align="left" valign="middle"><img src="$imagesdir/$micon.gif" alt=""></td>
                <td align="left" valign="middle">
                <font size="2"><B>$msub</b></font><BR>
                <font size="1">&#171; <B>$counterwords $txt{'30'}:</B> $messdate &#187;</font></td>
                <td align="right" valign="bottom" nowrap height="20">
                <font size=-1>
~;
if ($mstate != 1)
{
$yymain .= qq~
<a href="$cgi&action=reporttm&thread=$viewnum&id=$counter&subject=$msub&poster=$mname&username=$musername&email=$memail"><img src="$imagesdir/rtm.gif" alt="$rtm{'22'}" border="0"> <font size="1" class="imgwindowbg">$rtm{'22'}</font></a>
                $menusep
                <a href="$cgi;action=post;num=$viewnum;quote=$counter;title=$txt{'116'};start=$start">$img{'replyquote'}</a>$menusep<a href="$cgi;action=modify;message=$counter;thread=$viewnum">$img{'modify'}</a>
~;
	if(exists $moderators{$username} || $settings[7] eq 'Administrator' || $username eq $musername) {
		$yymain .= qq~  $menusep<a href="javascript:DoConfirm('$txt{'739'}','$cgi;action=modify2;thread=$viewnum;id=$counter;d=1')">$img{'delete'}</a>~;
		if((exists $moderators{$username} && $mdmod eq 1) || ($settings[7] eq 'Administrator' && $mdadmin eq 1) || ($settings[7] eq 'Global Moderator' && $mdglobal eq 1)) {
		$yymain .= qq~&nbsp;<input type="checkbox" name="del$counter" value="$counter">~;
		}
		
	}
}
	$yymain .= qq~
                </font></td>
              </tr>
            </table>
            <hr width="100%" size="1" class="hr">
            <font size="2">
            $message
            </font>
            </td>
          </tr><tr>
            <td class="$css" bgcolor="$windowbg" valign="bottom">
            <table width="100%" border="0">
              <tr>
                <td align="left"><font size="1">$lastmodified</font></td>
              </tr>
            </table>
            <font size="1">
            $userprofile[5]
            </font></td>  ~; 

if($columnpostshowbottom == '1' && ( $musername ne 'Guest' ))  { $yymain .= qq~
             </tr>
      <td width="20%" rowspan="2"></td><td width="80%"><hr width="100%" size="1" class="hr">  <BR>                 
                              $userprofile[8]  $icqad  ~;

	fopen(FILE, "$memberdir/$useraccount{$musername}.om", 1); 
        @msnsettings = <FILE>;
        fclose <FILE>;
        chomp @msnsettings;   
            if ($msnsettings[0] ne '')
            {
$yymain .= qq~
           <a id="lll" href=javascript:MsgrApp.LaunchIMUI("$msnsettings[0]")><img src="$imagesdir/msntalk.gif" alt="Chat to $msnsettings[0]" border=0></a>   
 
           <a href=javascript:MsgrApp.LaunchAddContactUI("$msnsettings[0]")><img src="$imagesdir/msnadd.gif" alt="Add $msnsettings[0] to your Buddy List" border=0></a>  ~;
        }



 $yymain .= qq~  $userprofile[10] $yimon &nbsp; $userprofile[9] 
~;

if ($userprofile[19] ne "checked" || $settings[7] eq "Administrator" || $allow_hide_email ne 1) {
		$yymain .= qq~
            $profbutton$userprofile[4] <a href="mailto:$memail">$img{'email_sm'}</a>$sendm
~;
	} else {
		$yymain .= qq~
    $profbutton$userprofile[4]$sendm
~;
	}

$yymain .= qq~</td>~;

}

	$yymain .= qq~


          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>~;
		$counter++;
	}
	$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">
        <table cellpadding="3" cellspacing="0" width="100%">
          <tr>
            <td><font size=2><b>$txt{'139'}:</b> $pageindex</font></td>
            <td class="catbg" bgcolor="$color{'catbg'}" align=right><font size=2>
            $replybutton$pollbutton$notify$menusep
            <a href="$cgi;action=sendtopic;topic=$viewnum">$img{'sendtopic'}</a>$menusep
            <a href="$cgi;action=print;board=$currentboard;num=$viewnum" target="_blank">$img{'print'}</a>
            </font></td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table><br>


<table width="100%" cellpadding="0" cellspacing="0">
  <tr>
    <td valign=bottom colspan="2" align="center"><font size="1" class="nav"><B>
    <a href="$scripturl" class="nav">$mbname</a> -&gt;  
    <a href="$scripturl#$curcat" class="nav">$cat</a> -&gt;  
    <a href="$cgi" class="nav">$boardname</a> -&gt;  
    $curthreadurl</b></font></td>
  </tr>
</table>
<br><br>

<table border="0" width="100%" cellpadding="0" cellspacing="0">~;
	  $yymain .= qq~
  <tr>
    <td align="left" valign="top" colspan="2">~;
	if(exists $moderators{$username} || $settings[7] eq 'Administrator') {
		$yymain .= qq~<font size="1"><b>$img{'admin_func'}</b>
        &nbsp;<a href="$cgi;action=movethread;thread=$viewnum">$img{'admin_move'}</a>$menusep
        <a href="javascript:DoConfirm('$txt{'162'}','$cgi;action=removethread;thread=$viewnum')">$img{'admin_rem'}</a>$menusep
        <a href="$cgi;action=lock;thread=$viewnum">$img{'admin_lock'}</a>$menusep
        <a href="$cgi;action=sticky;thread=$viewnum">$img{'admin_sticky'}</a>
~;
	if (!-e "$datadir/$viewnum.head") { $yymain .= qq~
        <a href="$cgi;action=addheader;thread=$viewnum">$img{'admin_header'}</a>~;}
	$yymain .= qq~
</font>~;
	}
	if((exists $moderators{$username} && $mdmod eq 1) || ($settings[7] eq 'Administrator' && $mdadmin eq 1) || ($settings[7] eq 'Global Moderator' && $mdglobal eq 1)) {	    
		if ($mstate != 1) {$yymain .= qq~<input type=submit value="$mdintxt{'3'}"></form>~;}
	}
	
	$yymain .= qq~
    </td>
    <td valign="top" height="18" align="right"><font size="1">$selecthtml</font></td>
  </tr><tr>
    <td colspan="3" valign="top" align="right"><font size="1">$nav</font></td>
  </tr>
</table>
~;
		if ($username ne "Guest" && $mstate != 1 && $enable_quickreply == 1) {
$yymain .= qq~
<form action="$cgi;action=post2" method="post" name="postmodify">
<input type="hidden" name="threadid" value="$viewnum">
<input type="hidden" name="icon" value="xx">
<table border=0 width="80%" cellspacing="1" cellpadding="4" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td align="center" class="titlebg" bgcolor="$color{'titlebg'}"><font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'172a'}</b></font></td>
  </tr>
  <tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}">
      <table width="100%" cellpadding="4" cellspacing="0">
        <tr>
          <td valign="top" width="23%"><font size="2"><b>$txt{'70'}:</b></font></td>
          <td><font size="2"><input type="text" name="subject" value="Re: $msubthread" size="40" style="width:100%"></td>
        </tr>
~;
		if ($enable_quicksmilies == 1) {
$yymain .= qq~
        <tr>
          <td valign="top" width="23%"><font size="2"><b>$txt{'297'}:</b></font></td>
          <td valign="middle">
          <script language="JavaScript1.2" type="text/javascript">
          <!--
            if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4)) {
              document.write("<a href=javascript:smiley()><img src='$imagesdir/smiley.gif' align='bottom' alt='$txt{'287'}' border='0'></a> ");
              document.write("<a href=javascript:wink()><img src='$imagesdir/wink.gif' align='bottom' alt='$txt{'292'}' border='0'></a> ");
              document.write("<a href=javascript:cheesy()><img src='$imagesdir/cheesy.gif' align='bottom' alt='$txt{'289'}' border='0'></a> ");
              document.write("<a href=javascript:grin()><img src='$imagesdir/grin.gif' align='bottom' alt='$txt{'293'}' border='0'></a> ");
              document.write("<a href=javascript:angry()><img src='$imagesdir/angry.gif' align='bottom' alt='$txt{'288'}' border='0'></a> ");
              document.write("<a href=javascript:sad()><img src='$imagesdir/sad.gif' align='bottom' alt='$txt{'291'}' border='0'></a> ");
              document.write("<a href=javascript:shocked()><img src='$imagesdir/shocked.gif' align='bottom' alt='$txt{'294'}' border='0'></a> ");
              document.write("<a href=javascript:cool()><img src='$imagesdir/cool.gif' align='bottom' alt='$txt{'295'}' border='0'></a> ");
              document.write("<a href=javascript:huh()><img src='$imagesdir/huh.gif' align='bottom' alt='$txt{'296'}' border='0'></a> ");
              document.write("<a href=javascript:rolleyes()><img src='$imagesdir/rolleyes.gif' align='bottom' alt='$txt{'450'}' border='0'></a> ");
              document.write("<a href=javascript:tongue()><img src='$imagesdir/tongue.gif' align='bottom' alt='$txt{'451'}' border='0'></a> ");
              document.write("<a href=javascript:embarassed()><img src='$imagesdir/embarassed.gif' align='bottom' alt='$txt{'526'}' border='0'></a> ");
              document.write("<a href=javascript:lipsrsealed()><img src='$imagesdir/lipsrsealed.gif' align='bottom' alt='$txt{'527'}' border='0'></a> ");
              document.write("<a href=javascript:undecided()><img src='$imagesdir/undecided.gif' align='bottom' alt='$txt{'528'}' border='0'></a> ");
              document.write("<a href=javascript:kiss()><img src='$imagesdir/kiss.gif' align='bottom' alt='$txt{'529'}' border='0'></a> ");
              document.write("<a href=javascript:cry()><img src='$imagesdir/cry.gif' align='bottom' alt='$txt{'530'}' border='0'></a> ");
            }
            else { document.write("<font size='1'>$txt{'215'}</font>"); }
          //-->
          </script>
          <noscript>
            <font size="1">$txt{'215'}</font>
          </noscript>
          </td>
        </tr>
~;
		}
$yymain .= qq~
        <tr>
          <td valign="top" width="23%"><font size="2"><b>$txt{'72'}:</b></font></td>
          <td><textarea name="message" rows="5" cols="60" wrap="soft" style="width:100%"></textarea></td>
        </tr>
      </table>
    </td>
  </tr>
  <tr>
    <td align="center" class="catbg" bgcolor="$color{'catbg'}"><input type="submit" name="$post" value="$txt{'105'}" accesskey="s"> &nbsp; <input type="reset" value="$txt{'278'}" accesskey="r"></td>
  </tr>
</table>
</form>
~;
	}
        $yytitle = $msubthread;
	&template;
	exit;
}

1;

